Unit ADG2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG4C_p, UTAFSI_p;

procedure ADG2C(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var DET1 :Complex; var DET2 :Real; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);

implementation

procedure ADG2C(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var DET1 :Complex; var DET2 :Real; var RCOND :Real;
                var Z :Array of Complex; var IERR :Integer);
var
I :Integer;
X :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
{ ****************************************************************C }
{   BCEHE OPEETE METOOM AYCCA C BOPOM BEYEO     C }
{   EMEHTA O CTOY  OEHKA CA OYCOBEHHOCT MATP A. C }
{ ****************************************************************C }
RCOND := 0.0;
DET1 := Cmplx(0.0,0.0);
DET2 := 0.0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( M >=  1 ) and (  N >=  1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','D','G','2','C',IERR);
goto _90;
_20:
IERR := 0;
AFG4C(A,M,N,NLEAD,RCOND,Z,IERR);
if ( IERR =  0 ) 
 then goto _30;
UTAFSI('A','D','G','2','C',IERR);
goto _90;
_30:
DET1 := Cmplx(1.0,0.0);
DET2 := 0.0;
for I:=1 to N do
 begin
  if ( NLEAD[I-1] <>  I ) 
   then DET1 := SubC(Cmplx(0.0,0.0),DET1);
  DET1 := MulC(A[(I-1)+(I-1)*M],DET1);
_40:
  if ( Cabs(DET1) >=  1.0 ) 
   then goto _50;
  DET1 := MulC(Cmplx(10.0,0.0),DET1);
  DET2 := DET2 - 1.0;
  goto _40;
_50:
_60:
  if ( Cabs(DET1) <  10.0 ) 
   then goto _70;
  DET1 := DivC(DET1,Cmplx(10.0,0.0));
  DET2 := DET2 + 1.0;
  goto _60;
_70:
_80:
 end;
_90:
end;

end.
